package org.example.domainmodel.parser.antlr.internal; 

import org.eclipse.xtext.*;
import org.eclipse.xtext.parser.*;
import org.eclipse.xtext.parser.impl.*;
import org.eclipse.emf.ecore.util.EcoreUtil;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.common.util.Enumerator;
import org.eclipse.xtext.parser.antlr.AbstractInternalAntlrParser;
import org.eclipse.xtext.parser.antlr.XtextTokenStream;
import org.eclipse.xtext.parser.antlr.XtextTokenStream.HiddenTokens;
import org.eclipse.xtext.parser.antlr.AntlrDatatypeRuleToken;
import org.example.domainmodel.services.DomainmodelGrammarAccess;



import org.antlr.runtime.*;
import java.util.Stack;
import java.util.List;
import java.util.ArrayList;

@SuppressWarnings("all")
public class InternalDomainmodelParser extends AbstractInternalAntlrParser {
    public static final String[] tokenNames = new String[] {
        "<invalid>", "<EOR>", "<DOWN>", "<UP>", "RULE_ID", "RULE_INT", "RULE_STRING", "RULE_ML_COMMENT", "RULE_SL_COMMENT", "RULE_WS", "RULE_ANY_OTHER", "'TDL Specification'", "'{'", "'}'", "'Data Set'", "'instance'", "';'", "'Test Configuration'", "'instantiate'", "'as'", "'of type'", "'having'", "'Component Type'", "'gate'", "'types'", "':'", "','", "'timer'", "'Gate Type'", "'accepts'", "'connect'", "'to'", "'and'", "'Test Description'", "'use'", "'configuration'", "'SUT'", "'Tester'"
    };
    public static final int RULE_STRING=6;
    public static final int RULE_SL_COMMENT=8;
    public static final int T__19=19;
    public static final int T__15=15;
    public static final int T__37=37;
    public static final int T__16=16;
    public static final int T__17=17;
    public static final int T__18=18;
    public static final int T__11=11;
    public static final int T__33=33;
    public static final int T__12=12;
    public static final int T__34=34;
    public static final int T__13=13;
    public static final int T__35=35;
    public static final int T__14=14;
    public static final int T__36=36;
    public static final int EOF=-1;
    public static final int T__30=30;
    public static final int T__31=31;
    public static final int T__32=32;
    public static final int RULE_ID=4;
    public static final int RULE_WS=9;
    public static final int RULE_ANY_OTHER=10;
    public static final int T__26=26;
    public static final int T__27=27;
    public static final int T__28=28;
    public static final int RULE_INT=5;
    public static final int T__29=29;
    public static final int T__22=22;
    public static final int RULE_ML_COMMENT=7;
    public static final int T__23=23;
    public static final int T__24=24;
    public static final int T__25=25;
    public static final int T__20=20;
    public static final int T__21=21;

    // delegates
    // delegators


        public InternalDomainmodelParser(TokenStream input) {
            this(input, new RecognizerSharedState());
        }
        public InternalDomainmodelParser(TokenStream input, RecognizerSharedState state) {
            super(input, state);
             
        }
        

    public String[] getTokenNames() { return InternalDomainmodelParser.tokenNames; }
    public String getGrammarFileName() { return "../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g"; }



     	private DomainmodelGrammarAccess grammarAccess;
     	
        public InternalDomainmodelParser(TokenStream input, DomainmodelGrammarAccess grammarAccess) {
            this(input);
            this.grammarAccess = grammarAccess;
            registerRules(grammarAccess.getGrammar());
        }
        
        @Override
        protected String getFirstRuleName() {
        	return "Domainmodel";	
       	}
       	
       	@Override
       	protected DomainmodelGrammarAccess getGrammarAccess() {
       		return grammarAccess;
       	}



    // $ANTLR start "entryRuleDomainmodel"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:68:1: entryRuleDomainmodel returns [EObject current=null] : iv_ruleDomainmodel= ruleDomainmodel EOF ;
    public final EObject entryRuleDomainmodel() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDomainmodel = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:69:2: (iv_ruleDomainmodel= ruleDomainmodel EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:70:2: iv_ruleDomainmodel= ruleDomainmodel EOF
            {
             newCompositeNode(grammarAccess.getDomainmodelRule()); 
            pushFollow(FOLLOW_ruleDomainmodel_in_entryRuleDomainmodel75);
            iv_ruleDomainmodel=ruleDomainmodel();

            state._fsp--;

             current =iv_ruleDomainmodel; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleDomainmodel85); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDomainmodel"


    // $ANTLR start "ruleDomainmodel"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:77:1: ruleDomainmodel returns [EObject current=null] : (otherlv_0= 'TDL Specification' otherlv_1= '{' ( (lv_elements_2_0= rulePackageableElement ) )* otherlv_3= '}' ) ;
    public final EObject ruleDomainmodel() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token otherlv_1=null;
        Token otherlv_3=null;
        EObject lv_elements_2_0 = null;


         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:80:28: ( (otherlv_0= 'TDL Specification' otherlv_1= '{' ( (lv_elements_2_0= rulePackageableElement ) )* otherlv_3= '}' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:81:1: (otherlv_0= 'TDL Specification' otherlv_1= '{' ( (lv_elements_2_0= rulePackageableElement ) )* otherlv_3= '}' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:81:1: (otherlv_0= 'TDL Specification' otherlv_1= '{' ( (lv_elements_2_0= rulePackageableElement ) )* otherlv_3= '}' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:81:3: otherlv_0= 'TDL Specification' otherlv_1= '{' ( (lv_elements_2_0= rulePackageableElement ) )* otherlv_3= '}'
            {
            otherlv_0=(Token)match(input,11,FOLLOW_11_in_ruleDomainmodel122); 

                	newLeafNode(otherlv_0, grammarAccess.getDomainmodelAccess().getTDLSpecificationKeyword_0());
                
            otherlv_1=(Token)match(input,12,FOLLOW_12_in_ruleDomainmodel134); 

                	newLeafNode(otherlv_1, grammarAccess.getDomainmodelAccess().getLeftCurlyBracketKeyword_1());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:89:1: ( (lv_elements_2_0= rulePackageableElement ) )*
            loop1:
            do {
                int alt1=2;
                int LA1_0 = input.LA(1);

                if ( (LA1_0==14||LA1_0==17||LA1_0==22||LA1_0==28||LA1_0==33) ) {
                    alt1=1;
                }


                switch (alt1) {
            	case 1 :
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:90:1: (lv_elements_2_0= rulePackageableElement )
            	    {
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:90:1: (lv_elements_2_0= rulePackageableElement )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:91:3: lv_elements_2_0= rulePackageableElement
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getDomainmodelAccess().getElementsPackageableElementParserRuleCall_2_0()); 
            	    	    
            	    pushFollow(FOLLOW_rulePackageableElement_in_ruleDomainmodel155);
            	    lv_elements_2_0=rulePackageableElement();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getDomainmodelRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"elements",
            	            		lv_elements_2_0, 
            	            		"PackageableElement");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop1;
                }
            } while (true);

            otherlv_3=(Token)match(input,13,FOLLOW_13_in_ruleDomainmodel168); 

                	newLeafNode(otherlv_3, grammarAccess.getDomainmodelAccess().getRightCurlyBracketKeyword_3());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDomainmodel"


    // $ANTLR start "entryRulePackageableElement"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:119:1: entryRulePackageableElement returns [EObject current=null] : iv_rulePackageableElement= rulePackageableElement EOF ;
    public final EObject entryRulePackageableElement() throws RecognitionException {
        EObject current = null;

        EObject iv_rulePackageableElement = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:120:2: (iv_rulePackageableElement= rulePackageableElement EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:121:2: iv_rulePackageableElement= rulePackageableElement EOF
            {
             newCompositeNode(grammarAccess.getPackageableElementRule()); 
            pushFollow(FOLLOW_rulePackageableElement_in_entryRulePackageableElement204);
            iv_rulePackageableElement=rulePackageableElement();

            state._fsp--;

             current =iv_rulePackageableElement; 
            match(input,EOF,FOLLOW_EOF_in_entryRulePackageableElement214); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRulePackageableElement"


    // $ANTLR start "rulePackageableElement"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:128:1: rulePackageableElement returns [EObject current=null] : (this_DataSet_0= ruleDataSet | this_TestConfiguration_1= ruleTestConfiguration | this_TestDescription_2= ruleTestDescription | this_ComponentType_3= ruleComponentType | this_GateType_4= ruleGateType ) ;
    public final EObject rulePackageableElement() throws RecognitionException {
        EObject current = null;

        EObject this_DataSet_0 = null;

        EObject this_TestConfiguration_1 = null;

        EObject this_TestDescription_2 = null;

        EObject this_ComponentType_3 = null;

        EObject this_GateType_4 = null;


         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:131:28: ( (this_DataSet_0= ruleDataSet | this_TestConfiguration_1= ruleTestConfiguration | this_TestDescription_2= ruleTestDescription | this_ComponentType_3= ruleComponentType | this_GateType_4= ruleGateType ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:132:1: (this_DataSet_0= ruleDataSet | this_TestConfiguration_1= ruleTestConfiguration | this_TestDescription_2= ruleTestDescription | this_ComponentType_3= ruleComponentType | this_GateType_4= ruleGateType )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:132:1: (this_DataSet_0= ruleDataSet | this_TestConfiguration_1= ruleTestConfiguration | this_TestDescription_2= ruleTestDescription | this_ComponentType_3= ruleComponentType | this_GateType_4= ruleGateType )
            int alt2=5;
            switch ( input.LA(1) ) {
            case 14:
                {
                alt2=1;
                }
                break;
            case 17:
                {
                alt2=2;
                }
                break;
            case 33:
                {
                alt2=3;
                }
                break;
            case 22:
                {
                alt2=4;
                }
                break;
            case 28:
                {
                alt2=5;
                }
                break;
            default:
                NoViableAltException nvae =
                    new NoViableAltException("", 2, 0, input);

                throw nvae;
            }

            switch (alt2) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:133:5: this_DataSet_0= ruleDataSet
                    {
                     
                            newCompositeNode(grammarAccess.getPackageableElementAccess().getDataSetParserRuleCall_0()); 
                        
                    pushFollow(FOLLOW_ruleDataSet_in_rulePackageableElement261);
                    this_DataSet_0=ruleDataSet();

                    state._fsp--;

                     
                            current = this_DataSet_0; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 2 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:143:5: this_TestConfiguration_1= ruleTestConfiguration
                    {
                     
                            newCompositeNode(grammarAccess.getPackageableElementAccess().getTestConfigurationParserRuleCall_1()); 
                        
                    pushFollow(FOLLOW_ruleTestConfiguration_in_rulePackageableElement288);
                    this_TestConfiguration_1=ruleTestConfiguration();

                    state._fsp--;

                     
                            current = this_TestConfiguration_1; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 3 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:153:5: this_TestDescription_2= ruleTestDescription
                    {
                     
                            newCompositeNode(grammarAccess.getPackageableElementAccess().getTestDescriptionParserRuleCall_2()); 
                        
                    pushFollow(FOLLOW_ruleTestDescription_in_rulePackageableElement315);
                    this_TestDescription_2=ruleTestDescription();

                    state._fsp--;

                     
                            current = this_TestDescription_2; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 4 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:163:5: this_ComponentType_3= ruleComponentType
                    {
                     
                            newCompositeNode(grammarAccess.getPackageableElementAccess().getComponentTypeParserRuleCall_3()); 
                        
                    pushFollow(FOLLOW_ruleComponentType_in_rulePackageableElement342);
                    this_ComponentType_3=ruleComponentType();

                    state._fsp--;

                     
                            current = this_ComponentType_3; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;
                case 5 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:173:5: this_GateType_4= ruleGateType
                    {
                     
                            newCompositeNode(grammarAccess.getPackageableElementAccess().getGateTypeParserRuleCall_4()); 
                        
                    pushFollow(FOLLOW_ruleGateType_in_rulePackageableElement369);
                    this_GateType_4=ruleGateType();

                    state._fsp--;

                     
                            current = this_GateType_4; 
                            afterParserOrEnumRuleCall();
                        

                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "rulePackageableElement"


    // $ANTLR start "entryRuleDataSet"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:189:1: entryRuleDataSet returns [EObject current=null] : iv_ruleDataSet= ruleDataSet EOF ;
    public final EObject entryRuleDataSet() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDataSet = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:190:2: (iv_ruleDataSet= ruleDataSet EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:191:2: iv_ruleDataSet= ruleDataSet EOF
            {
             newCompositeNode(grammarAccess.getDataSetRule()); 
            pushFollow(FOLLOW_ruleDataSet_in_entryRuleDataSet404);
            iv_ruleDataSet=ruleDataSet();

            state._fsp--;

             current =iv_ruleDataSet; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleDataSet414); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDataSet"


    // $ANTLR start "ruleDataSet"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:198:1: ruleDataSet returns [EObject current=null] : (otherlv_0= 'Data Set' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( ( (lv_dataInstance_3_0= ruleDataInstance ) ) ( (lv_dataInstance_4_0= ruleDataInstance ) )* )? otherlv_5= '}' ) ;
    public final EObject ruleDataSet() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_5=null;
        EObject lv_dataInstance_3_0 = null;

        EObject lv_dataInstance_4_0 = null;


         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:201:28: ( (otherlv_0= 'Data Set' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( ( (lv_dataInstance_3_0= ruleDataInstance ) ) ( (lv_dataInstance_4_0= ruleDataInstance ) )* )? otherlv_5= '}' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:202:1: (otherlv_0= 'Data Set' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( ( (lv_dataInstance_3_0= ruleDataInstance ) ) ( (lv_dataInstance_4_0= ruleDataInstance ) )* )? otherlv_5= '}' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:202:1: (otherlv_0= 'Data Set' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( ( (lv_dataInstance_3_0= ruleDataInstance ) ) ( (lv_dataInstance_4_0= ruleDataInstance ) )* )? otherlv_5= '}' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:202:3: otherlv_0= 'Data Set' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( ( (lv_dataInstance_3_0= ruleDataInstance ) ) ( (lv_dataInstance_4_0= ruleDataInstance ) )* )? otherlv_5= '}'
            {
            otherlv_0=(Token)match(input,14,FOLLOW_14_in_ruleDataSet451); 

                	newLeafNode(otherlv_0, grammarAccess.getDataSetAccess().getDataSetKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:206:1: ( (lv_name_1_0= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:207:1: (lv_name_1_0= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:207:1: (lv_name_1_0= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:208:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleDataSet468); 

            			newLeafNode(lv_name_1_0, grammarAccess.getDataSetAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getDataSetRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_ruleDataSet485); 

                	newLeafNode(otherlv_2, grammarAccess.getDataSetAccess().getLeftCurlyBracketKeyword_2());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:228:1: ( ( (lv_dataInstance_3_0= ruleDataInstance ) ) ( (lv_dataInstance_4_0= ruleDataInstance ) )* )?
            int alt4=2;
            int LA4_0 = input.LA(1);

            if ( (LA4_0==15) ) {
                alt4=1;
            }
            switch (alt4) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:228:2: ( (lv_dataInstance_3_0= ruleDataInstance ) ) ( (lv_dataInstance_4_0= ruleDataInstance ) )*
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:228:2: ( (lv_dataInstance_3_0= ruleDataInstance ) )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:229:1: (lv_dataInstance_3_0= ruleDataInstance )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:229:1: (lv_dataInstance_3_0= ruleDataInstance )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:230:3: lv_dataInstance_3_0= ruleDataInstance
                    {
                     
                    	        newCompositeNode(grammarAccess.getDataSetAccess().getDataInstanceDataInstanceParserRuleCall_3_0_0()); 
                    	    
                    pushFollow(FOLLOW_ruleDataInstance_in_ruleDataSet507);
                    lv_dataInstance_3_0=ruleDataInstance();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getDataSetRule());
                    	        }
                           		add(
                           			current, 
                           			"dataInstance",
                            		lv_dataInstance_3_0, 
                            		"DataInstance");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:246:2: ( (lv_dataInstance_4_0= ruleDataInstance ) )*
                    loop3:
                    do {
                        int alt3=2;
                        int LA3_0 = input.LA(1);

                        if ( (LA3_0==15) ) {
                            alt3=1;
                        }


                        switch (alt3) {
                    	case 1 :
                    	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:247:1: (lv_dataInstance_4_0= ruleDataInstance )
                    	    {
                    	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:247:1: (lv_dataInstance_4_0= ruleDataInstance )
                    	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:248:3: lv_dataInstance_4_0= ruleDataInstance
                    	    {
                    	     
                    	    	        newCompositeNode(grammarAccess.getDataSetAccess().getDataInstanceDataInstanceParserRuleCall_3_1_0()); 
                    	    	    
                    	    pushFollow(FOLLOW_ruleDataInstance_in_ruleDataSet528);
                    	    lv_dataInstance_4_0=ruleDataInstance();

                    	    state._fsp--;


                    	    	        if (current==null) {
                    	    	            current = createModelElementForParent(grammarAccess.getDataSetRule());
                    	    	        }
                    	           		add(
                    	           			current, 
                    	           			"dataInstance",
                    	            		lv_dataInstance_4_0, 
                    	            		"DataInstance");
                    	    	        afterParserOrEnumRuleCall();
                    	    	    

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop3;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_5=(Token)match(input,13,FOLLOW_13_in_ruleDataSet543); 

                	newLeafNode(otherlv_5, grammarAccess.getDataSetAccess().getRightCurlyBracketKeyword_4());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDataSet"


    // $ANTLR start "entryRuleDataInstance"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:276:1: entryRuleDataInstance returns [EObject current=null] : iv_ruleDataInstance= ruleDataInstance EOF ;
    public final EObject entryRuleDataInstance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleDataInstance = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:277:2: (iv_ruleDataInstance= ruleDataInstance EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:278:2: iv_ruleDataInstance= ruleDataInstance EOF
            {
             newCompositeNode(grammarAccess.getDataInstanceRule()); 
            pushFollow(FOLLOW_ruleDataInstance_in_entryRuleDataInstance579);
            iv_ruleDataInstance=ruleDataInstance();

            state._fsp--;

             current =iv_ruleDataInstance; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleDataInstance589); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleDataInstance"


    // $ANTLR start "ruleDataInstance"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:285:1: ruleDataInstance returns [EObject current=null] : (otherlv_0= 'instance' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= ';' ) ;
    public final EObject ruleDataInstance() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;

         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:288:28: ( (otherlv_0= 'instance' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= ';' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:289:1: (otherlv_0= 'instance' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= ';' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:289:1: (otherlv_0= 'instance' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= ';' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:289:3: otherlv_0= 'instance' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= ';'
            {
            otherlv_0=(Token)match(input,15,FOLLOW_15_in_ruleDataInstance626); 

                	newLeafNode(otherlv_0, grammarAccess.getDataInstanceAccess().getInstanceKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:293:1: ( (lv_name_1_0= RULE_ID ) )?
            int alt5=2;
            int LA5_0 = input.LA(1);

            if ( (LA5_0==RULE_ID) ) {
                alt5=1;
            }
            switch (alt5) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:294:1: (lv_name_1_0= RULE_ID )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:294:1: (lv_name_1_0= RULE_ID )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:295:3: lv_name_1_0= RULE_ID
                    {
                    lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleDataInstance643); 

                    			newLeafNode(lv_name_1_0, grammarAccess.getDataInstanceAccess().getNameIDTerminalRuleCall_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getDataInstanceRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"name",
                            		lv_name_1_0, 
                            		"ID");
                    	    

                    }


                    }
                    break;

            }

            otherlv_2=(Token)match(input,16,FOLLOW_16_in_ruleDataInstance661); 

                	newLeafNode(otherlv_2, grammarAccess.getDataInstanceAccess().getSemicolonKeyword_2());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleDataInstance"


    // $ANTLR start "entryRuleTestConfiguration"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:323:1: entryRuleTestConfiguration returns [EObject current=null] : iv_ruleTestConfiguration= ruleTestConfiguration EOF ;
    public final EObject entryRuleTestConfiguration() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTestConfiguration = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:324:2: (iv_ruleTestConfiguration= ruleTestConfiguration EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:325:2: iv_ruleTestConfiguration= ruleTestConfiguration EOF
            {
             newCompositeNode(grammarAccess.getTestConfigurationRule()); 
            pushFollow(FOLLOW_ruleTestConfiguration_in_entryRuleTestConfiguration697);
            iv_ruleTestConfiguration=ruleTestConfiguration();

            state._fsp--;

             current =iv_ruleTestConfiguration; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleTestConfiguration707); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTestConfiguration"


    // $ANTLR start "ruleTestConfiguration"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:332:1: ruleTestConfiguration returns [EObject current=null] : (otherlv_0= 'Test Configuration' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_componentInstance_3_0= ruleComponentInstance ) ) ( (lv_componentInstance_4_0= ruleComponentInstance ) )* ( (lv_connection_5_0= ruleConnection ) ) ( (lv_connection_6_0= ruleConnection ) )* otherlv_7= '}' ) ;
    public final EObject ruleTestConfiguration() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_7=null;
        EObject lv_componentInstance_3_0 = null;

        EObject lv_componentInstance_4_0 = null;

        EObject lv_connection_5_0 = null;

        EObject lv_connection_6_0 = null;


         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:335:28: ( (otherlv_0= 'Test Configuration' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_componentInstance_3_0= ruleComponentInstance ) ) ( (lv_componentInstance_4_0= ruleComponentInstance ) )* ( (lv_connection_5_0= ruleConnection ) ) ( (lv_connection_6_0= ruleConnection ) )* otherlv_7= '}' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:336:1: (otherlv_0= 'Test Configuration' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_componentInstance_3_0= ruleComponentInstance ) ) ( (lv_componentInstance_4_0= ruleComponentInstance ) )* ( (lv_connection_5_0= ruleConnection ) ) ( (lv_connection_6_0= ruleConnection ) )* otherlv_7= '}' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:336:1: (otherlv_0= 'Test Configuration' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_componentInstance_3_0= ruleComponentInstance ) ) ( (lv_componentInstance_4_0= ruleComponentInstance ) )* ( (lv_connection_5_0= ruleConnection ) ) ( (lv_connection_6_0= ruleConnection ) )* otherlv_7= '}' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:336:3: otherlv_0= 'Test Configuration' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' ( (lv_componentInstance_3_0= ruleComponentInstance ) ) ( (lv_componentInstance_4_0= ruleComponentInstance ) )* ( (lv_connection_5_0= ruleConnection ) ) ( (lv_connection_6_0= ruleConnection ) )* otherlv_7= '}'
            {
            otherlv_0=(Token)match(input,17,FOLLOW_17_in_ruleTestConfiguration744); 

                	newLeafNode(otherlv_0, grammarAccess.getTestConfigurationAccess().getTestConfigurationKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:340:1: ( (lv_name_1_0= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:341:1: (lv_name_1_0= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:341:1: (lv_name_1_0= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:342:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleTestConfiguration761); 

            			newLeafNode(lv_name_1_0, grammarAccess.getTestConfigurationAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getTestConfigurationRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_ruleTestConfiguration778); 

                	newLeafNode(otherlv_2, grammarAccess.getTestConfigurationAccess().getLeftCurlyBracketKeyword_2());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:362:1: ( (lv_componentInstance_3_0= ruleComponentInstance ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:363:1: (lv_componentInstance_3_0= ruleComponentInstance )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:363:1: (lv_componentInstance_3_0= ruleComponentInstance )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:364:3: lv_componentInstance_3_0= ruleComponentInstance
            {
             
            	        newCompositeNode(grammarAccess.getTestConfigurationAccess().getComponentInstanceComponentInstanceParserRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_ruleComponentInstance_in_ruleTestConfiguration799);
            lv_componentInstance_3_0=ruleComponentInstance();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getTestConfigurationRule());
            	        }
                   		add(
                   			current, 
                   			"componentInstance",
                    		lv_componentInstance_3_0, 
                    		"ComponentInstance");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:380:2: ( (lv_componentInstance_4_0= ruleComponentInstance ) )*
            loop6:
            do {
                int alt6=2;
                int LA6_0 = input.LA(1);

                if ( (LA6_0==18) ) {
                    alt6=1;
                }


                switch (alt6) {
            	case 1 :
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:381:1: (lv_componentInstance_4_0= ruleComponentInstance )
            	    {
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:381:1: (lv_componentInstance_4_0= ruleComponentInstance )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:382:3: lv_componentInstance_4_0= ruleComponentInstance
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getTestConfigurationAccess().getComponentInstanceComponentInstanceParserRuleCall_4_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleComponentInstance_in_ruleTestConfiguration820);
            	    lv_componentInstance_4_0=ruleComponentInstance();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getTestConfigurationRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"componentInstance",
            	            		lv_componentInstance_4_0, 
            	            		"ComponentInstance");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop6;
                }
            } while (true);

            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:398:3: ( (lv_connection_5_0= ruleConnection ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:399:1: (lv_connection_5_0= ruleConnection )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:399:1: (lv_connection_5_0= ruleConnection )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:400:3: lv_connection_5_0= ruleConnection
            {
             
            	        newCompositeNode(grammarAccess.getTestConfigurationAccess().getConnectionConnectionParserRuleCall_5_0()); 
            	    
            pushFollow(FOLLOW_ruleConnection_in_ruleTestConfiguration842);
            lv_connection_5_0=ruleConnection();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getTestConfigurationRule());
            	        }
                   		add(
                   			current, 
                   			"connection",
                    		lv_connection_5_0, 
                    		"Connection");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:416:2: ( (lv_connection_6_0= ruleConnection ) )*
            loop7:
            do {
                int alt7=2;
                int LA7_0 = input.LA(1);

                if ( (LA7_0==30) ) {
                    alt7=1;
                }


                switch (alt7) {
            	case 1 :
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:417:1: (lv_connection_6_0= ruleConnection )
            	    {
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:417:1: (lv_connection_6_0= ruleConnection )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:418:3: lv_connection_6_0= ruleConnection
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getTestConfigurationAccess().getConnectionConnectionParserRuleCall_6_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleConnection_in_ruleTestConfiguration863);
            	    lv_connection_6_0=ruleConnection();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getTestConfigurationRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"connection",
            	            		lv_connection_6_0, 
            	            		"Connection");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop7;
                }
            } while (true);

            otherlv_7=(Token)match(input,13,FOLLOW_13_in_ruleTestConfiguration876); 

                	newLeafNode(otherlv_7, grammarAccess.getTestConfigurationAccess().getRightCurlyBracketKeyword_7());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTestConfiguration"


    // $ANTLR start "entryRuleComponentInstance"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:446:1: entryRuleComponentInstance returns [EObject current=null] : iv_ruleComponentInstance= ruleComponentInstance EOF ;
    public final EObject entryRuleComponentInstance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleComponentInstance = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:447:2: (iv_ruleComponentInstance= ruleComponentInstance EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:448:2: iv_ruleComponentInstance= ruleComponentInstance EOF
            {
             newCompositeNode(grammarAccess.getComponentInstanceRule()); 
            pushFollow(FOLLOW_ruleComponentInstance_in_entryRuleComponentInstance912);
            iv_ruleComponentInstance=ruleComponentInstance();

            state._fsp--;

             current =iv_ruleComponentInstance; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleComponentInstance922); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleComponentInstance"


    // $ANTLR start "ruleComponentInstance"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:455:1: ruleComponentInstance returns [EObject current=null] : (otherlv_0= 'instantiate' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'as' ( (lv_role_3_0= ruleComponentInstanceRole ) ) otherlv_4= 'of type' ( (otherlv_5= RULE_ID ) ) otherlv_6= 'having' otherlv_7= '{' ( (lv_gateInstance_8_0= ruleGateInstance ) ) ( (lv_gateInstance_9_0= ruleGateInstance ) )* otherlv_10= '}' ) ;
    public final EObject ruleComponentInstance() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_10=null;
        Enumerator lv_role_3_0 = null;

        EObject lv_gateInstance_8_0 = null;

        EObject lv_gateInstance_9_0 = null;


         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:458:28: ( (otherlv_0= 'instantiate' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'as' ( (lv_role_3_0= ruleComponentInstanceRole ) ) otherlv_4= 'of type' ( (otherlv_5= RULE_ID ) ) otherlv_6= 'having' otherlv_7= '{' ( (lv_gateInstance_8_0= ruleGateInstance ) ) ( (lv_gateInstance_9_0= ruleGateInstance ) )* otherlv_10= '}' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:459:1: (otherlv_0= 'instantiate' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'as' ( (lv_role_3_0= ruleComponentInstanceRole ) ) otherlv_4= 'of type' ( (otherlv_5= RULE_ID ) ) otherlv_6= 'having' otherlv_7= '{' ( (lv_gateInstance_8_0= ruleGateInstance ) ) ( (lv_gateInstance_9_0= ruleGateInstance ) )* otherlv_10= '}' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:459:1: (otherlv_0= 'instantiate' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'as' ( (lv_role_3_0= ruleComponentInstanceRole ) ) otherlv_4= 'of type' ( (otherlv_5= RULE_ID ) ) otherlv_6= 'having' otherlv_7= '{' ( (lv_gateInstance_8_0= ruleGateInstance ) ) ( (lv_gateInstance_9_0= ruleGateInstance ) )* otherlv_10= '}' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:459:3: otherlv_0= 'instantiate' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'as' ( (lv_role_3_0= ruleComponentInstanceRole ) ) otherlv_4= 'of type' ( (otherlv_5= RULE_ID ) ) otherlv_6= 'having' otherlv_7= '{' ( (lv_gateInstance_8_0= ruleGateInstance ) ) ( (lv_gateInstance_9_0= ruleGateInstance ) )* otherlv_10= '}'
            {
            otherlv_0=(Token)match(input,18,FOLLOW_18_in_ruleComponentInstance959); 

                	newLeafNode(otherlv_0, grammarAccess.getComponentInstanceAccess().getInstantiateKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:463:1: ( (lv_name_1_0= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:464:1: (lv_name_1_0= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:464:1: (lv_name_1_0= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:465:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleComponentInstance976); 

            			newLeafNode(lv_name_1_0, grammarAccess.getComponentInstanceAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getComponentInstanceRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,19,FOLLOW_19_in_ruleComponentInstance993); 

                	newLeafNode(otherlv_2, grammarAccess.getComponentInstanceAccess().getAsKeyword_2());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:485:1: ( (lv_role_3_0= ruleComponentInstanceRole ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:486:1: (lv_role_3_0= ruleComponentInstanceRole )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:486:1: (lv_role_3_0= ruleComponentInstanceRole )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:487:3: lv_role_3_0= ruleComponentInstanceRole
            {
             
            	        newCompositeNode(grammarAccess.getComponentInstanceAccess().getRoleComponentInstanceRoleEnumRuleCall_3_0()); 
            	    
            pushFollow(FOLLOW_ruleComponentInstanceRole_in_ruleComponentInstance1014);
            lv_role_3_0=ruleComponentInstanceRole();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getComponentInstanceRule());
            	        }
                   		set(
                   			current, 
                   			"role",
                    		lv_role_3_0, 
                    		"ComponentInstanceRole");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            otherlv_4=(Token)match(input,20,FOLLOW_20_in_ruleComponentInstance1026); 

                	newLeafNode(otherlv_4, grammarAccess.getComponentInstanceAccess().getOfTypeKeyword_4());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:507:1: ( (otherlv_5= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:508:1: (otherlv_5= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:508:1: (otherlv_5= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:509:3: otherlv_5= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getComponentInstanceRule());
            	        }
                    
            otherlv_5=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleComponentInstance1046); 

            		newLeafNode(otherlv_5, grammarAccess.getComponentInstanceAccess().getTypeComponentTypeCrossReference_5_0()); 
            	

            }


            }

            otherlv_6=(Token)match(input,21,FOLLOW_21_in_ruleComponentInstance1058); 

                	newLeafNode(otherlv_6, grammarAccess.getComponentInstanceAccess().getHavingKeyword_6());
                
            otherlv_7=(Token)match(input,12,FOLLOW_12_in_ruleComponentInstance1070); 

                	newLeafNode(otherlv_7, grammarAccess.getComponentInstanceAccess().getLeftCurlyBracketKeyword_7());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:528:1: ( (lv_gateInstance_8_0= ruleGateInstance ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:529:1: (lv_gateInstance_8_0= ruleGateInstance )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:529:1: (lv_gateInstance_8_0= ruleGateInstance )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:530:3: lv_gateInstance_8_0= ruleGateInstance
            {
             
            	        newCompositeNode(grammarAccess.getComponentInstanceAccess().getGateInstanceGateInstanceParserRuleCall_8_0()); 
            	    
            pushFollow(FOLLOW_ruleGateInstance_in_ruleComponentInstance1091);
            lv_gateInstance_8_0=ruleGateInstance();

            state._fsp--;


            	        if (current==null) {
            	            current = createModelElementForParent(grammarAccess.getComponentInstanceRule());
            	        }
                   		add(
                   			current, 
                   			"gateInstance",
                    		lv_gateInstance_8_0, 
                    		"GateInstance");
            	        afterParserOrEnumRuleCall();
            	    

            }


            }

            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:546:2: ( (lv_gateInstance_9_0= ruleGateInstance ) )*
            loop8:
            do {
                int alt8=2;
                int LA8_0 = input.LA(1);

                if ( (LA8_0==23) ) {
                    alt8=1;
                }


                switch (alt8) {
            	case 1 :
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:547:1: (lv_gateInstance_9_0= ruleGateInstance )
            	    {
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:547:1: (lv_gateInstance_9_0= ruleGateInstance )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:548:3: lv_gateInstance_9_0= ruleGateInstance
            	    {
            	     
            	    	        newCompositeNode(grammarAccess.getComponentInstanceAccess().getGateInstanceGateInstanceParserRuleCall_9_0()); 
            	    	    
            	    pushFollow(FOLLOW_ruleGateInstance_in_ruleComponentInstance1112);
            	    lv_gateInstance_9_0=ruleGateInstance();

            	    state._fsp--;


            	    	        if (current==null) {
            	    	            current = createModelElementForParent(grammarAccess.getComponentInstanceRule());
            	    	        }
            	           		add(
            	           			current, 
            	           			"gateInstance",
            	            		lv_gateInstance_9_0, 
            	            		"GateInstance");
            	    	        afterParserOrEnumRuleCall();
            	    	    

            	    }


            	    }
            	    break;

            	default :
            	    break loop8;
                }
            } while (true);

            otherlv_10=(Token)match(input,13,FOLLOW_13_in_ruleComponentInstance1125); 

                	newLeafNode(otherlv_10, grammarAccess.getComponentInstanceAccess().getRightCurlyBracketKeyword_10());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleComponentInstance"


    // $ANTLR start "entryRuleComponentType"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:576:1: entryRuleComponentType returns [EObject current=null] : iv_ruleComponentType= ruleComponentType EOF ;
    public final EObject entryRuleComponentType() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleComponentType = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:577:2: (iv_ruleComponentType= ruleComponentType EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:578:2: iv_ruleComponentType= ruleComponentType EOF
            {
             newCompositeNode(grammarAccess.getComponentTypeRule()); 
            pushFollow(FOLLOW_ruleComponentType_in_entryRuleComponentType1161);
            iv_ruleComponentType=ruleComponentType();

            state._fsp--;

             current =iv_ruleComponentType; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleComponentType1171); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleComponentType"


    // $ANTLR start "ruleComponentType"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:585:1: ruleComponentType returns [EObject current=null] : (otherlv_0= 'Component Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= '{' ( ( (lv_timer_3_0= ruleTimer ) ) ( (lv_timer_4_0= ruleTimer ) )* )? otherlv_5= 'gate' otherlv_6= 'types' otherlv_7= ':' ( (otherlv_8= RULE_ID ) ) (otherlv_9= ',' ( (otherlv_10= RULE_ID ) ) )* otherlv_11= ';' otherlv_12= '}' ) ;
    public final EObject ruleComponentType() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;
        Token otherlv_9=null;
        Token otherlv_10=null;
        Token otherlv_11=null;
        Token otherlv_12=null;
        EObject lv_timer_3_0 = null;

        EObject lv_timer_4_0 = null;


         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:588:28: ( (otherlv_0= 'Component Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= '{' ( ( (lv_timer_3_0= ruleTimer ) ) ( (lv_timer_4_0= ruleTimer ) )* )? otherlv_5= 'gate' otherlv_6= 'types' otherlv_7= ':' ( (otherlv_8= RULE_ID ) ) (otherlv_9= ',' ( (otherlv_10= RULE_ID ) ) )* otherlv_11= ';' otherlv_12= '}' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:589:1: (otherlv_0= 'Component Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= '{' ( ( (lv_timer_3_0= ruleTimer ) ) ( (lv_timer_4_0= ruleTimer ) )* )? otherlv_5= 'gate' otherlv_6= 'types' otherlv_7= ':' ( (otherlv_8= RULE_ID ) ) (otherlv_9= ',' ( (otherlv_10= RULE_ID ) ) )* otherlv_11= ';' otherlv_12= '}' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:589:1: (otherlv_0= 'Component Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= '{' ( ( (lv_timer_3_0= ruleTimer ) ) ( (lv_timer_4_0= ruleTimer ) )* )? otherlv_5= 'gate' otherlv_6= 'types' otherlv_7= ':' ( (otherlv_8= RULE_ID ) ) (otherlv_9= ',' ( (otherlv_10= RULE_ID ) ) )* otherlv_11= ';' otherlv_12= '}' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:589:3: otherlv_0= 'Component Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= '{' ( ( (lv_timer_3_0= ruleTimer ) ) ( (lv_timer_4_0= ruleTimer ) )* )? otherlv_5= 'gate' otherlv_6= 'types' otherlv_7= ':' ( (otherlv_8= RULE_ID ) ) (otherlv_9= ',' ( (otherlv_10= RULE_ID ) ) )* otherlv_11= ';' otherlv_12= '}'
            {
            otherlv_0=(Token)match(input,22,FOLLOW_22_in_ruleComponentType1208); 

                	newLeafNode(otherlv_0, grammarAccess.getComponentTypeAccess().getComponentTypeKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:593:1: ( (lv_name_1_0= RULE_ID ) )?
            int alt9=2;
            int LA9_0 = input.LA(1);

            if ( (LA9_0==RULE_ID) ) {
                alt9=1;
            }
            switch (alt9) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:594:1: (lv_name_1_0= RULE_ID )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:594:1: (lv_name_1_0= RULE_ID )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:595:3: lv_name_1_0= RULE_ID
                    {
                    lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleComponentType1225); 

                    			newLeafNode(lv_name_1_0, grammarAccess.getComponentTypeAccess().getNameIDTerminalRuleCall_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getComponentTypeRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"name",
                            		lv_name_1_0, 
                            		"ID");
                    	    

                    }


                    }
                    break;

            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_ruleComponentType1243); 

                	newLeafNode(otherlv_2, grammarAccess.getComponentTypeAccess().getLeftCurlyBracketKeyword_2());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:615:1: ( ( (lv_timer_3_0= ruleTimer ) ) ( (lv_timer_4_0= ruleTimer ) )* )?
            int alt11=2;
            int LA11_0 = input.LA(1);

            if ( (LA11_0==27) ) {
                alt11=1;
            }
            switch (alt11) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:615:2: ( (lv_timer_3_0= ruleTimer ) ) ( (lv_timer_4_0= ruleTimer ) )*
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:615:2: ( (lv_timer_3_0= ruleTimer ) )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:616:1: (lv_timer_3_0= ruleTimer )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:616:1: (lv_timer_3_0= ruleTimer )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:617:3: lv_timer_3_0= ruleTimer
                    {
                     
                    	        newCompositeNode(grammarAccess.getComponentTypeAccess().getTimerTimerParserRuleCall_3_0_0()); 
                    	    
                    pushFollow(FOLLOW_ruleTimer_in_ruleComponentType1265);
                    lv_timer_3_0=ruleTimer();

                    state._fsp--;


                    	        if (current==null) {
                    	            current = createModelElementForParent(grammarAccess.getComponentTypeRule());
                    	        }
                           		add(
                           			current, 
                           			"timer",
                            		lv_timer_3_0, 
                            		"Timer");
                    	        afterParserOrEnumRuleCall();
                    	    

                    }


                    }

                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:633:2: ( (lv_timer_4_0= ruleTimer ) )*
                    loop10:
                    do {
                        int alt10=2;
                        int LA10_0 = input.LA(1);

                        if ( (LA10_0==27) ) {
                            alt10=1;
                        }


                        switch (alt10) {
                    	case 1 :
                    	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:634:1: (lv_timer_4_0= ruleTimer )
                    	    {
                    	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:634:1: (lv_timer_4_0= ruleTimer )
                    	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:635:3: lv_timer_4_0= ruleTimer
                    	    {
                    	     
                    	    	        newCompositeNode(grammarAccess.getComponentTypeAccess().getTimerTimerParserRuleCall_3_1_0()); 
                    	    	    
                    	    pushFollow(FOLLOW_ruleTimer_in_ruleComponentType1286);
                    	    lv_timer_4_0=ruleTimer();

                    	    state._fsp--;


                    	    	        if (current==null) {
                    	    	            current = createModelElementForParent(grammarAccess.getComponentTypeRule());
                    	    	        }
                    	           		add(
                    	           			current, 
                    	           			"timer",
                    	            		lv_timer_4_0, 
                    	            		"Timer");
                    	    	        afterParserOrEnumRuleCall();
                    	    	    

                    	    }


                    	    }
                    	    break;

                    	default :
                    	    break loop10;
                        }
                    } while (true);


                    }
                    break;

            }

            otherlv_5=(Token)match(input,23,FOLLOW_23_in_ruleComponentType1301); 

                	newLeafNode(otherlv_5, grammarAccess.getComponentTypeAccess().getGateKeyword_4());
                
            otherlv_6=(Token)match(input,24,FOLLOW_24_in_ruleComponentType1313); 

                	newLeafNode(otherlv_6, grammarAccess.getComponentTypeAccess().getTypesKeyword_5());
                
            otherlv_7=(Token)match(input,25,FOLLOW_25_in_ruleComponentType1325); 

                	newLeafNode(otherlv_7, grammarAccess.getComponentTypeAccess().getColonKeyword_6());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:663:1: ( (otherlv_8= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:664:1: (otherlv_8= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:664:1: (otherlv_8= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:665:3: otherlv_8= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getComponentTypeRule());
            	        }
                    
            otherlv_8=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleComponentType1345); 

            		newLeafNode(otherlv_8, grammarAccess.getComponentTypeAccess().getGateTypeGateTypeCrossReference_7_0()); 
            	

            }


            }

            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:676:2: (otherlv_9= ',' ( (otherlv_10= RULE_ID ) ) )*
            loop12:
            do {
                int alt12=2;
                int LA12_0 = input.LA(1);

                if ( (LA12_0==26) ) {
                    alt12=1;
                }


                switch (alt12) {
            	case 1 :
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:676:4: otherlv_9= ',' ( (otherlv_10= RULE_ID ) )
            	    {
            	    otherlv_9=(Token)match(input,26,FOLLOW_26_in_ruleComponentType1358); 

            	        	newLeafNode(otherlv_9, grammarAccess.getComponentTypeAccess().getCommaKeyword_8_0());
            	        
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:680:1: ( (otherlv_10= RULE_ID ) )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:681:1: (otherlv_10= RULE_ID )
            	    {
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:681:1: (otherlv_10= RULE_ID )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:682:3: otherlv_10= RULE_ID
            	    {

            	    			if (current==null) {
            	    	            current = createModelElement(grammarAccess.getComponentTypeRule());
            	    	        }
            	            
            	    otherlv_10=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleComponentType1378); 

            	    		newLeafNode(otherlv_10, grammarAccess.getComponentTypeAccess().getGateTypeGateTypeCrossReference_8_1_0()); 
            	    	

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop12;
                }
            } while (true);

            otherlv_11=(Token)match(input,16,FOLLOW_16_in_ruleComponentType1392); 

                	newLeafNode(otherlv_11, grammarAccess.getComponentTypeAccess().getSemicolonKeyword_9());
                
            otherlv_12=(Token)match(input,13,FOLLOW_13_in_ruleComponentType1404); 

                	newLeafNode(otherlv_12, grammarAccess.getComponentTypeAccess().getRightCurlyBracketKeyword_10());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleComponentType"


    // $ANTLR start "entryRuleTimer"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:709:1: entryRuleTimer returns [EObject current=null] : iv_ruleTimer= ruleTimer EOF ;
    public final EObject entryRuleTimer() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTimer = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:710:2: (iv_ruleTimer= ruleTimer EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:711:2: iv_ruleTimer= ruleTimer EOF
            {
             newCompositeNode(grammarAccess.getTimerRule()); 
            pushFollow(FOLLOW_ruleTimer_in_entryRuleTimer1440);
            iv_ruleTimer=ruleTimer();

            state._fsp--;

             current =iv_ruleTimer; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleTimer1450); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTimer"


    // $ANTLR start "ruleTimer"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:718:1: ruleTimer returns [EObject current=null] : ( () otherlv_1= 'timer' ( (lv_name_2_0= RULE_ID ) )? ) ;
    public final EObject ruleTimer() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_name_2_0=null;

         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:721:28: ( ( () otherlv_1= 'timer' ( (lv_name_2_0= RULE_ID ) )? ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:722:1: ( () otherlv_1= 'timer' ( (lv_name_2_0= RULE_ID ) )? )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:722:1: ( () otherlv_1= 'timer' ( (lv_name_2_0= RULE_ID ) )? )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:722:2: () otherlv_1= 'timer' ( (lv_name_2_0= RULE_ID ) )?
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:722:2: ()
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:723:5: 
            {

                    current = forceCreateModelElement(
                        grammarAccess.getTimerAccess().getTimerAction_0(),
                        current);
                

            }

            otherlv_1=(Token)match(input,27,FOLLOW_27_in_ruleTimer1496); 

                	newLeafNode(otherlv_1, grammarAccess.getTimerAccess().getTimerKeyword_1());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:732:1: ( (lv_name_2_0= RULE_ID ) )?
            int alt13=2;
            int LA13_0 = input.LA(1);

            if ( (LA13_0==RULE_ID) ) {
                alt13=1;
            }
            switch (alt13) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:733:1: (lv_name_2_0= RULE_ID )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:733:1: (lv_name_2_0= RULE_ID )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:734:3: lv_name_2_0= RULE_ID
                    {
                    lv_name_2_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleTimer1513); 

                    			newLeafNode(lv_name_2_0, grammarAccess.getTimerAccess().getNameIDTerminalRuleCall_2_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getTimerRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"name",
                            		lv_name_2_0, 
                            		"ID");
                    	    

                    }


                    }
                    break;

            }


            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTimer"


    // $ANTLR start "entryRuleGateType"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:758:1: entryRuleGateType returns [EObject current=null] : iv_ruleGateType= ruleGateType EOF ;
    public final EObject entryRuleGateType() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGateType = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:759:2: (iv_ruleGateType= ruleGateType EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:760:2: iv_ruleGateType= ruleGateType EOF
            {
             newCompositeNode(grammarAccess.getGateTypeRule()); 
            pushFollow(FOLLOW_ruleGateType_in_entryRuleGateType1555);
            iv_ruleGateType=ruleGateType();

            state._fsp--;

             current =iv_ruleGateType; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleGateType1565); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGateType"


    // $ANTLR start "ruleGateType"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:767:1: ruleGateType returns [EObject current=null] : (otherlv_0= 'Gate Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= 'accepts' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ';' ) ;
    public final EObject ruleGateType() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;

         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:770:28: ( (otherlv_0= 'Gate Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= 'accepts' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ';' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:771:1: (otherlv_0= 'Gate Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= 'accepts' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ';' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:771:1: (otherlv_0= 'Gate Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= 'accepts' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ';' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:771:3: otherlv_0= 'Gate Type' ( (lv_name_1_0= RULE_ID ) )? otherlv_2= 'accepts' ( (otherlv_3= RULE_ID ) ) (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )* otherlv_6= ';'
            {
            otherlv_0=(Token)match(input,28,FOLLOW_28_in_ruleGateType1602); 

                	newLeafNode(otherlv_0, grammarAccess.getGateTypeAccess().getGateTypeKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:775:1: ( (lv_name_1_0= RULE_ID ) )?
            int alt14=2;
            int LA14_0 = input.LA(1);

            if ( (LA14_0==RULE_ID) ) {
                alt14=1;
            }
            switch (alt14) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:776:1: (lv_name_1_0= RULE_ID )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:776:1: (lv_name_1_0= RULE_ID )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:777:3: lv_name_1_0= RULE_ID
                    {
                    lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleGateType1619); 

                    			newLeafNode(lv_name_1_0, grammarAccess.getGateTypeAccess().getNameIDTerminalRuleCall_1_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getGateTypeRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"name",
                            		lv_name_1_0, 
                            		"ID");
                    	    

                    }


                    }
                    break;

            }

            otherlv_2=(Token)match(input,29,FOLLOW_29_in_ruleGateType1637); 

                	newLeafNode(otherlv_2, grammarAccess.getGateTypeAccess().getAcceptsKeyword_2());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:797:1: ( (otherlv_3= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:798:1: (otherlv_3= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:798:1: (otherlv_3= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:799:3: otherlv_3= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getGateTypeRule());
            	        }
                    
            otherlv_3=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleGateType1657); 

            		newLeafNode(otherlv_3, grammarAccess.getGateTypeAccess().getDataSetDataSetCrossReference_3_0()); 
            	

            }


            }

            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:810:2: (otherlv_4= ',' ( (otherlv_5= RULE_ID ) ) )*
            loop15:
            do {
                int alt15=2;
                int LA15_0 = input.LA(1);

                if ( (LA15_0==26) ) {
                    alt15=1;
                }


                switch (alt15) {
            	case 1 :
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:810:4: otherlv_4= ',' ( (otherlv_5= RULE_ID ) )
            	    {
            	    otherlv_4=(Token)match(input,26,FOLLOW_26_in_ruleGateType1670); 

            	        	newLeafNode(otherlv_4, grammarAccess.getGateTypeAccess().getCommaKeyword_4_0());
            	        
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:814:1: ( (otherlv_5= RULE_ID ) )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:815:1: (otherlv_5= RULE_ID )
            	    {
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:815:1: (otherlv_5= RULE_ID )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:816:3: otherlv_5= RULE_ID
            	    {

            	    			if (current==null) {
            	    	            current = createModelElement(grammarAccess.getGateTypeRule());
            	    	        }
            	            
            	    otherlv_5=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleGateType1690); 

            	    		newLeafNode(otherlv_5, grammarAccess.getGateTypeAccess().getDataSetDataSetCrossReference_4_1_0()); 
            	    	

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop15;
                }
            } while (true);

            otherlv_6=(Token)match(input,16,FOLLOW_16_in_ruleGateType1704); 

                	newLeafNode(otherlv_6, grammarAccess.getGateTypeAccess().getSemicolonKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGateType"


    // $ANTLR start "entryRuleGateInstance"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:839:1: entryRuleGateInstance returns [EObject current=null] : iv_ruleGateInstance= ruleGateInstance EOF ;
    public final EObject entryRuleGateInstance() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleGateInstance = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:840:2: (iv_ruleGateInstance= ruleGateInstance EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:841:2: iv_ruleGateInstance= ruleGateInstance EOF
            {
             newCompositeNode(grammarAccess.getGateInstanceRule()); 
            pushFollow(FOLLOW_ruleGateInstance_in_entryRuleGateInstance1740);
            iv_ruleGateInstance=ruleGateInstance();

            state._fsp--;

             current =iv_ruleGateInstance; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleGateInstance1750); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleGateInstance"


    // $ANTLR start "ruleGateInstance"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:848:1: ruleGateInstance returns [EObject current=null] : ( () otherlv_1= 'gate' ( (lv_name_2_0= RULE_ID ) )? otherlv_3= 'of type' ( (otherlv_4= RULE_ID ) ) otherlv_5= ';' ) ;
    public final EObject ruleGateInstance() throws RecognitionException {
        EObject current = null;

        Token otherlv_1=null;
        Token lv_name_2_0=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;

         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:851:28: ( ( () otherlv_1= 'gate' ( (lv_name_2_0= RULE_ID ) )? otherlv_3= 'of type' ( (otherlv_4= RULE_ID ) ) otherlv_5= ';' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:852:1: ( () otherlv_1= 'gate' ( (lv_name_2_0= RULE_ID ) )? otherlv_3= 'of type' ( (otherlv_4= RULE_ID ) ) otherlv_5= ';' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:852:1: ( () otherlv_1= 'gate' ( (lv_name_2_0= RULE_ID ) )? otherlv_3= 'of type' ( (otherlv_4= RULE_ID ) ) otherlv_5= ';' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:852:2: () otherlv_1= 'gate' ( (lv_name_2_0= RULE_ID ) )? otherlv_3= 'of type' ( (otherlv_4= RULE_ID ) ) otherlv_5= ';'
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:852:2: ()
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:853:5: 
            {

                    current = forceCreateModelElement(
                        grammarAccess.getGateInstanceAccess().getGateInstanceAction_0(),
                        current);
                

            }

            otherlv_1=(Token)match(input,23,FOLLOW_23_in_ruleGateInstance1796); 

                	newLeafNode(otherlv_1, grammarAccess.getGateInstanceAccess().getGateKeyword_1());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:862:1: ( (lv_name_2_0= RULE_ID ) )?
            int alt16=2;
            int LA16_0 = input.LA(1);

            if ( (LA16_0==RULE_ID) ) {
                alt16=1;
            }
            switch (alt16) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:863:1: (lv_name_2_0= RULE_ID )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:863:1: (lv_name_2_0= RULE_ID )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:864:3: lv_name_2_0= RULE_ID
                    {
                    lv_name_2_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleGateInstance1813); 

                    			newLeafNode(lv_name_2_0, grammarAccess.getGateInstanceAccess().getNameIDTerminalRuleCall_2_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getGateInstanceRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"name",
                            		lv_name_2_0, 
                            		"ID");
                    	    

                    }


                    }
                    break;

            }

            otherlv_3=(Token)match(input,20,FOLLOW_20_in_ruleGateInstance1831); 

                	newLeafNode(otherlv_3, grammarAccess.getGateInstanceAccess().getOfTypeKeyword_3());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:884:1: ( (otherlv_4= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:885:1: (otherlv_4= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:885:1: (otherlv_4= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:886:3: otherlv_4= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getGateInstanceRule());
            	        }
                    
            otherlv_4=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleGateInstance1851); 

            		newLeafNode(otherlv_4, grammarAccess.getGateInstanceAccess().getTypeGateTypeCrossReference_4_0()); 
            	

            }


            }

            otherlv_5=(Token)match(input,16,FOLLOW_16_in_ruleGateInstance1863); 

                	newLeafNode(otherlv_5, grammarAccess.getGateInstanceAccess().getSemicolonKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleGateInstance"


    // $ANTLR start "entryRuleConnection"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:909:1: entryRuleConnection returns [EObject current=null] : iv_ruleConnection= ruleConnection EOF ;
    public final EObject entryRuleConnection() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleConnection = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:910:2: (iv_ruleConnection= ruleConnection EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:911:2: iv_ruleConnection= ruleConnection EOF
            {
             newCompositeNode(grammarAccess.getConnectionRule()); 
            pushFollow(FOLLOW_ruleConnection_in_entryRuleConnection1899);
            iv_ruleConnection=ruleConnection();

            state._fsp--;

             current =iv_ruleConnection; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleConnection1909); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleConnection"


    // $ANTLR start "ruleConnection"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:918:1: ruleConnection returns [EObject current=null] : (otherlv_0= 'connect' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'to' ( (lv_name_3_0= RULE_ID ) )? (otherlv_4= 'and' ( (lv_name_5_0= RULE_ID ) ) )* otherlv_6= ';' ) ;
    public final EObject ruleConnection() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token lv_name_3_0=null;
        Token otherlv_4=null;
        Token lv_name_5_0=null;
        Token otherlv_6=null;

         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:921:28: ( (otherlv_0= 'connect' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'to' ( (lv_name_3_0= RULE_ID ) )? (otherlv_4= 'and' ( (lv_name_5_0= RULE_ID ) ) )* otherlv_6= ';' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:922:1: (otherlv_0= 'connect' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'to' ( (lv_name_3_0= RULE_ID ) )? (otherlv_4= 'and' ( (lv_name_5_0= RULE_ID ) ) )* otherlv_6= ';' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:922:1: (otherlv_0= 'connect' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'to' ( (lv_name_3_0= RULE_ID ) )? (otherlv_4= 'and' ( (lv_name_5_0= RULE_ID ) ) )* otherlv_6= ';' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:922:3: otherlv_0= 'connect' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= 'to' ( (lv_name_3_0= RULE_ID ) )? (otherlv_4= 'and' ( (lv_name_5_0= RULE_ID ) ) )* otherlv_6= ';'
            {
            otherlv_0=(Token)match(input,30,FOLLOW_30_in_ruleConnection1946); 

                	newLeafNode(otherlv_0, grammarAccess.getConnectionAccess().getConnectKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:926:1: ( (lv_name_1_0= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:927:1: (lv_name_1_0= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:927:1: (lv_name_1_0= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:928:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleConnection1963); 

            			newLeafNode(lv_name_1_0, grammarAccess.getConnectionAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getConnectionRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,31,FOLLOW_31_in_ruleConnection1980); 

                	newLeafNode(otherlv_2, grammarAccess.getConnectionAccess().getToKeyword_2());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:948:1: ( (lv_name_3_0= RULE_ID ) )?
            int alt17=2;
            int LA17_0 = input.LA(1);

            if ( (LA17_0==RULE_ID) ) {
                alt17=1;
            }
            switch (alt17) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:949:1: (lv_name_3_0= RULE_ID )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:949:1: (lv_name_3_0= RULE_ID )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:950:3: lv_name_3_0= RULE_ID
                    {
                    lv_name_3_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleConnection1997); 

                    			newLeafNode(lv_name_3_0, grammarAccess.getConnectionAccess().getNameIDTerminalRuleCall_3_0()); 
                    		

                    	        if (current==null) {
                    	            current = createModelElement(grammarAccess.getConnectionRule());
                    	        }
                           		setWithLastConsumed(
                           			current, 
                           			"name",
                            		lv_name_3_0, 
                            		"ID");
                    	    

                    }


                    }
                    break;

            }

            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:966:3: (otherlv_4= 'and' ( (lv_name_5_0= RULE_ID ) ) )*
            loop18:
            do {
                int alt18=2;
                int LA18_0 = input.LA(1);

                if ( (LA18_0==32) ) {
                    alt18=1;
                }


                switch (alt18) {
            	case 1 :
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:966:5: otherlv_4= 'and' ( (lv_name_5_0= RULE_ID ) )
            	    {
            	    otherlv_4=(Token)match(input,32,FOLLOW_32_in_ruleConnection2016); 

            	        	newLeafNode(otherlv_4, grammarAccess.getConnectionAccess().getAndKeyword_4_0());
            	        
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:970:1: ( (lv_name_5_0= RULE_ID ) )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:971:1: (lv_name_5_0= RULE_ID )
            	    {
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:971:1: (lv_name_5_0= RULE_ID )
            	    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:972:3: lv_name_5_0= RULE_ID
            	    {
            	    lv_name_5_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleConnection2033); 

            	    			newLeafNode(lv_name_5_0, grammarAccess.getConnectionAccess().getNameIDTerminalRuleCall_4_1_0()); 
            	    		

            	    	        if (current==null) {
            	    	            current = createModelElement(grammarAccess.getConnectionRule());
            	    	        }
            	           		setWithLastConsumed(
            	           			current, 
            	           			"name",
            	            		lv_name_5_0, 
            	            		"ID");
            	    	    

            	    }


            	    }


            	    }
            	    break;

            	default :
            	    break loop18;
                }
            } while (true);

            otherlv_6=(Token)match(input,16,FOLLOW_16_in_ruleConnection2052); 

                	newLeafNode(otherlv_6, grammarAccess.getConnectionAccess().getSemicolonKeyword_5());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleConnection"


    // $ANTLR start "entryRuleTestDescription"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1000:1: entryRuleTestDescription returns [EObject current=null] : iv_ruleTestDescription= ruleTestDescription EOF ;
    public final EObject entryRuleTestDescription() throws RecognitionException {
        EObject current = null;

        EObject iv_ruleTestDescription = null;


        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1001:2: (iv_ruleTestDescription= ruleTestDescription EOF )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1002:2: iv_ruleTestDescription= ruleTestDescription EOF
            {
             newCompositeNode(grammarAccess.getTestDescriptionRule()); 
            pushFollow(FOLLOW_ruleTestDescription_in_entryRuleTestDescription2088);
            iv_ruleTestDescription=ruleTestDescription();

            state._fsp--;

             current =iv_ruleTestDescription; 
            match(input,EOF,FOLLOW_EOF_in_entryRuleTestDescription2098); 

            }

        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "entryRuleTestDescription"


    // $ANTLR start "ruleTestDescription"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1009:1: ruleTestDescription returns [EObject current=null] : (otherlv_0= 'Test Description' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'use' otherlv_4= 'configuration' otherlv_5= ':' ( (otherlv_6= RULE_ID ) ) otherlv_7= ';' otherlv_8= '}' ) ;
    public final EObject ruleTestDescription() throws RecognitionException {
        EObject current = null;

        Token otherlv_0=null;
        Token lv_name_1_0=null;
        Token otherlv_2=null;
        Token otherlv_3=null;
        Token otherlv_4=null;
        Token otherlv_5=null;
        Token otherlv_6=null;
        Token otherlv_7=null;
        Token otherlv_8=null;

         enterRule(); 
            
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1012:28: ( (otherlv_0= 'Test Description' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'use' otherlv_4= 'configuration' otherlv_5= ':' ( (otherlv_6= RULE_ID ) ) otherlv_7= ';' otherlv_8= '}' ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1013:1: (otherlv_0= 'Test Description' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'use' otherlv_4= 'configuration' otherlv_5= ':' ( (otherlv_6= RULE_ID ) ) otherlv_7= ';' otherlv_8= '}' )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1013:1: (otherlv_0= 'Test Description' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'use' otherlv_4= 'configuration' otherlv_5= ':' ( (otherlv_6= RULE_ID ) ) otherlv_7= ';' otherlv_8= '}' )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1013:3: otherlv_0= 'Test Description' ( (lv_name_1_0= RULE_ID ) ) otherlv_2= '{' otherlv_3= 'use' otherlv_4= 'configuration' otherlv_5= ':' ( (otherlv_6= RULE_ID ) ) otherlv_7= ';' otherlv_8= '}'
            {
            otherlv_0=(Token)match(input,33,FOLLOW_33_in_ruleTestDescription2135); 

                	newLeafNode(otherlv_0, grammarAccess.getTestDescriptionAccess().getTestDescriptionKeyword_0());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1017:1: ( (lv_name_1_0= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1018:1: (lv_name_1_0= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1018:1: (lv_name_1_0= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1019:3: lv_name_1_0= RULE_ID
            {
            lv_name_1_0=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleTestDescription2152); 

            			newLeafNode(lv_name_1_0, grammarAccess.getTestDescriptionAccess().getNameIDTerminalRuleCall_1_0()); 
            		

            	        if (current==null) {
            	            current = createModelElement(grammarAccess.getTestDescriptionRule());
            	        }
                   		setWithLastConsumed(
                   			current, 
                   			"name",
                    		lv_name_1_0, 
                    		"ID");
            	    

            }


            }

            otherlv_2=(Token)match(input,12,FOLLOW_12_in_ruleTestDescription2169); 

                	newLeafNode(otherlv_2, grammarAccess.getTestDescriptionAccess().getLeftCurlyBracketKeyword_2());
                
            otherlv_3=(Token)match(input,34,FOLLOW_34_in_ruleTestDescription2181); 

                	newLeafNode(otherlv_3, grammarAccess.getTestDescriptionAccess().getUseKeyword_3());
                
            otherlv_4=(Token)match(input,35,FOLLOW_35_in_ruleTestDescription2193); 

                	newLeafNode(otherlv_4, grammarAccess.getTestDescriptionAccess().getConfigurationKeyword_4());
                
            otherlv_5=(Token)match(input,25,FOLLOW_25_in_ruleTestDescription2205); 

                	newLeafNode(otherlv_5, grammarAccess.getTestDescriptionAccess().getColonKeyword_5());
                
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1051:1: ( (otherlv_6= RULE_ID ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1052:1: (otherlv_6= RULE_ID )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1052:1: (otherlv_6= RULE_ID )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1053:3: otherlv_6= RULE_ID
            {

            			if (current==null) {
            	            current = createModelElement(grammarAccess.getTestDescriptionRule());
            	        }
                    
            otherlv_6=(Token)match(input,RULE_ID,FOLLOW_RULE_ID_in_ruleTestDescription2225); 

            		newLeafNode(otherlv_6, grammarAccess.getTestDescriptionAccess().getTestConfigurationTestConfigurationCrossReference_6_0()); 
            	

            }


            }

            otherlv_7=(Token)match(input,16,FOLLOW_16_in_ruleTestDescription2237); 

                	newLeafNode(otherlv_7, grammarAccess.getTestDescriptionAccess().getSemicolonKeyword_7());
                
            otherlv_8=(Token)match(input,13,FOLLOW_13_in_ruleTestDescription2249); 

                	newLeafNode(otherlv_8, grammarAccess.getTestDescriptionAccess().getRightCurlyBracketKeyword_8());
                

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleTestDescription"


    // $ANTLR start "ruleComponentInstanceRole"
    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1080:1: ruleComponentInstanceRole returns [Enumerator current=null] : ( (enumLiteral_0= 'SUT' ) | (enumLiteral_1= 'Tester' ) ) ;
    public final Enumerator ruleComponentInstanceRole() throws RecognitionException {
        Enumerator current = null;

        Token enumLiteral_0=null;
        Token enumLiteral_1=null;

         enterRule(); 
        try {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1082:28: ( ( (enumLiteral_0= 'SUT' ) | (enumLiteral_1= 'Tester' ) ) )
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1083:1: ( (enumLiteral_0= 'SUT' ) | (enumLiteral_1= 'Tester' ) )
            {
            // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1083:1: ( (enumLiteral_0= 'SUT' ) | (enumLiteral_1= 'Tester' ) )
            int alt19=2;
            int LA19_0 = input.LA(1);

            if ( (LA19_0==36) ) {
                alt19=1;
            }
            else if ( (LA19_0==37) ) {
                alt19=2;
            }
            else {
                NoViableAltException nvae =
                    new NoViableAltException("", 19, 0, input);

                throw nvae;
            }
            switch (alt19) {
                case 1 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1083:2: (enumLiteral_0= 'SUT' )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1083:2: (enumLiteral_0= 'SUT' )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1083:4: enumLiteral_0= 'SUT'
                    {
                    enumLiteral_0=(Token)match(input,36,FOLLOW_36_in_ruleComponentInstanceRole2299); 

                            current = grammarAccess.getComponentInstanceRoleAccess().getSUTEnumLiteralDeclaration_0().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_0, grammarAccess.getComponentInstanceRoleAccess().getSUTEnumLiteralDeclaration_0()); 
                        

                    }


                    }
                    break;
                case 2 :
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1089:6: (enumLiteral_1= 'Tester' )
                    {
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1089:6: (enumLiteral_1= 'Tester' )
                    // ../org.example.domainmodel/src-gen/org/example/domainmodel/parser/antlr/internal/InternalDomainmodel.g:1089:8: enumLiteral_1= 'Tester'
                    {
                    enumLiteral_1=(Token)match(input,37,FOLLOW_37_in_ruleComponentInstanceRole2316); 

                            current = grammarAccess.getComponentInstanceRoleAccess().getTesterEnumLiteralDeclaration_1().getEnumLiteral().getInstance();
                            newLeafNode(enumLiteral_1, grammarAccess.getComponentInstanceRoleAccess().getTesterEnumLiteralDeclaration_1()); 
                        

                    }


                    }
                    break;

            }


            }

             leaveRule(); 
        }
         
            catch (RecognitionException re) { 
                recover(input,re); 
                appendSkippedTokens();
            } 
        finally {
        }
        return current;
    }
    // $ANTLR end "ruleComponentInstanceRole"

    // Delegated rules


 

    public static final BitSet FOLLOW_ruleDomainmodel_in_entryRuleDomainmodel75 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleDomainmodel85 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_11_in_ruleDomainmodel122 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleDomainmodel134 = new BitSet(new long[]{0x0000000210426000L});
    public static final BitSet FOLLOW_rulePackageableElement_in_ruleDomainmodel155 = new BitSet(new long[]{0x0000000210426000L});
    public static final BitSet FOLLOW_13_in_ruleDomainmodel168 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_rulePackageableElement_in_entryRulePackageableElement204 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRulePackageableElement214 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleDataSet_in_rulePackageableElement261 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleTestConfiguration_in_rulePackageableElement288 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleTestDescription_in_rulePackageableElement315 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleComponentType_in_rulePackageableElement342 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleGateType_in_rulePackageableElement369 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleDataSet_in_entryRuleDataSet404 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleDataSet414 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_14_in_ruleDataSet451 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleDataSet468 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleDataSet485 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_ruleDataInstance_in_ruleDataSet507 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_ruleDataInstance_in_ruleDataSet528 = new BitSet(new long[]{0x000000000000A000L});
    public static final BitSet FOLLOW_13_in_ruleDataSet543 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleDataInstance_in_entryRuleDataInstance579 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleDataInstance589 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_15_in_ruleDataInstance626 = new BitSet(new long[]{0x0000000000010010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleDataInstance643 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_ruleDataInstance661 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleTestConfiguration_in_entryRuleTestConfiguration697 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleTestConfiguration707 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_17_in_ruleTestConfiguration744 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleTestConfiguration761 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleTestConfiguration778 = new BitSet(new long[]{0x0000000000040000L});
    public static final BitSet FOLLOW_ruleComponentInstance_in_ruleTestConfiguration799 = new BitSet(new long[]{0x0000000040040000L});
    public static final BitSet FOLLOW_ruleComponentInstance_in_ruleTestConfiguration820 = new BitSet(new long[]{0x0000000040040000L});
    public static final BitSet FOLLOW_ruleConnection_in_ruleTestConfiguration842 = new BitSet(new long[]{0x0000000040042000L});
    public static final BitSet FOLLOW_ruleConnection_in_ruleTestConfiguration863 = new BitSet(new long[]{0x0000000040042000L});
    public static final BitSet FOLLOW_13_in_ruleTestConfiguration876 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleComponentInstance_in_entryRuleComponentInstance912 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleComponentInstance922 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_18_in_ruleComponentInstance959 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleComponentInstance976 = new BitSet(new long[]{0x0000000000080000L});
    public static final BitSet FOLLOW_19_in_ruleComponentInstance993 = new BitSet(new long[]{0x0000003000000000L});
    public static final BitSet FOLLOW_ruleComponentInstanceRole_in_ruleComponentInstance1014 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_ruleComponentInstance1026 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleComponentInstance1046 = new BitSet(new long[]{0x0000000000200000L});
    public static final BitSet FOLLOW_21_in_ruleComponentInstance1058 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleComponentInstance1070 = new BitSet(new long[]{0x0000000000800000L});
    public static final BitSet FOLLOW_ruleGateInstance_in_ruleComponentInstance1091 = new BitSet(new long[]{0x0000000000802000L});
    public static final BitSet FOLLOW_ruleGateInstance_in_ruleComponentInstance1112 = new BitSet(new long[]{0x0000000000802000L});
    public static final BitSet FOLLOW_13_in_ruleComponentInstance1125 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleComponentType_in_entryRuleComponentType1161 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleComponentType1171 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_22_in_ruleComponentType1208 = new BitSet(new long[]{0x0000000000001010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleComponentType1225 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleComponentType1243 = new BitSet(new long[]{0x0000000008800000L});
    public static final BitSet FOLLOW_ruleTimer_in_ruleComponentType1265 = new BitSet(new long[]{0x0000000008800000L});
    public static final BitSet FOLLOW_ruleTimer_in_ruleComponentType1286 = new BitSet(new long[]{0x0000000008800000L});
    public static final BitSet FOLLOW_23_in_ruleComponentType1301 = new BitSet(new long[]{0x0000000001000000L});
    public static final BitSet FOLLOW_24_in_ruleComponentType1313 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_ruleComponentType1325 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleComponentType1345 = new BitSet(new long[]{0x0000000004010000L});
    public static final BitSet FOLLOW_26_in_ruleComponentType1358 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleComponentType1378 = new BitSet(new long[]{0x0000000004010000L});
    public static final BitSet FOLLOW_16_in_ruleComponentType1392 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleComponentType1404 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleTimer_in_entryRuleTimer1440 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleTimer1450 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_27_in_ruleTimer1496 = new BitSet(new long[]{0x0000000000000012L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleTimer1513 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleGateType_in_entryRuleGateType1555 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleGateType1565 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_28_in_ruleGateType1602 = new BitSet(new long[]{0x0000000020000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleGateType1619 = new BitSet(new long[]{0x0000000020000000L});
    public static final BitSet FOLLOW_29_in_ruleGateType1637 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleGateType1657 = new BitSet(new long[]{0x0000000004010000L});
    public static final BitSet FOLLOW_26_in_ruleGateType1670 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleGateType1690 = new BitSet(new long[]{0x0000000004010000L});
    public static final BitSet FOLLOW_16_in_ruleGateType1704 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleGateInstance_in_entryRuleGateInstance1740 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleGateInstance1750 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_23_in_ruleGateInstance1796 = new BitSet(new long[]{0x0000000000100010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleGateInstance1813 = new BitSet(new long[]{0x0000000000100000L});
    public static final BitSet FOLLOW_20_in_ruleGateInstance1831 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleGateInstance1851 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_ruleGateInstance1863 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleConnection_in_entryRuleConnection1899 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleConnection1909 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_30_in_ruleConnection1946 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleConnection1963 = new BitSet(new long[]{0x0000000080000000L});
    public static final BitSet FOLLOW_31_in_ruleConnection1980 = new BitSet(new long[]{0x0000000100010010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleConnection1997 = new BitSet(new long[]{0x0000000100010000L});
    public static final BitSet FOLLOW_32_in_ruleConnection2016 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleConnection2033 = new BitSet(new long[]{0x0000000100010000L});
    public static final BitSet FOLLOW_16_in_ruleConnection2052 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_ruleTestDescription_in_entryRuleTestDescription2088 = new BitSet(new long[]{0x0000000000000000L});
    public static final BitSet FOLLOW_EOF_in_entryRuleTestDescription2098 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_33_in_ruleTestDescription2135 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleTestDescription2152 = new BitSet(new long[]{0x0000000000001000L});
    public static final BitSet FOLLOW_12_in_ruleTestDescription2169 = new BitSet(new long[]{0x0000000400000000L});
    public static final BitSet FOLLOW_34_in_ruleTestDescription2181 = new BitSet(new long[]{0x0000000800000000L});
    public static final BitSet FOLLOW_35_in_ruleTestDescription2193 = new BitSet(new long[]{0x0000000002000000L});
    public static final BitSet FOLLOW_25_in_ruleTestDescription2205 = new BitSet(new long[]{0x0000000000000010L});
    public static final BitSet FOLLOW_RULE_ID_in_ruleTestDescription2225 = new BitSet(new long[]{0x0000000000010000L});
    public static final BitSet FOLLOW_16_in_ruleTestDescription2237 = new BitSet(new long[]{0x0000000000002000L});
    public static final BitSet FOLLOW_13_in_ruleTestDescription2249 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_36_in_ruleComponentInstanceRole2299 = new BitSet(new long[]{0x0000000000000002L});
    public static final BitSet FOLLOW_37_in_ruleComponentInstanceRole2316 = new BitSet(new long[]{0x0000000000000002L});

}